Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.opensymphony.oscache.base.algorithm
Class AbstractConcurrentReadCache

    java.lang.Object
      java.util.AbstractMap
          com.opensymphony.oscache.base.algorithm.AbstractConcurrentReadCache

All Implemented Interfaces:
  java.lang.Cloneable, java.util.Map, java.io.Serializable

Direct Known Subclasses:
  FIFOCache, LRUCache, UnlimitedCache

public abstract class AbstractConcurrentReadCache
extends java.util.AbstractMap
implements java.util.Map, java.lang.Cloneable, java.io.Serializable

A version of Hashtable that supports mostly-concurrent reading, but exclusive writing. Because reads are not limited to periods without writes, a concurrent reader policy is weaker than a classic reader/writer policy, but is generally faster and allows more concurrency. This class is a good choice especially for tables that are mainly created by one thread during the start-up phase of a program, and from then on, are mainly read (with perhaps occasional additions or removals) in many threads. If you also need concurrency among writes, consider instead using ConcurrentHashMap.

Successful retrievals using get(key) and containsKey(key) usually run without locking. Unsuccessful ones (i.e., when the key is not present) do involve brief synchronization (locking). Also, the size and isEmpty methods are always synchronized.

Because retrieval operations can ordinarily overlap with writing operations (i.e., put, remove, and their derivatives), retrievals can only be guaranteed to return the results of the most recently completed operations holding upon their onset. Retrieval operations may or may not return results reflecting in-progress writing operations. However, the retrieval operations do always return consistent results -- either those holding before any single modification or after it, but never a nonsense result. For aggregate operations such as putAll and clear, concurrent reads may reflect insertion or removal of only some entries. In those rare contexts in which you use a hash table to synchronize operations across threads (for example, to prevent reads until after clears), you should either encase operations in synchronized blocks, or instead use java.util.Hashtable.

This class also supports optional guaranteed exclusive reads, simply by surrounding a call within a synchronized block, as in
`AbstractConcurrentReadCache t; ... Object v;
synchronized(t) { v = t.get(k); }`
But this is not usually necessary in practice. For example, it is generally inefficient to write:

       AbstractConcurrentReadCache t; ...            // Inefficient version
       Object key; ...
       Object value; ...
       synchronized(t) {
         if (!t.containsKey(key))
           t.put(key, value);
           // other code if not previously present
         }
         else {
           // other code if it was previously present
         }
       }

Instead, just take advantage of the fact that put returns null if the key was not previously present:

       AbstractConcurrentReadCache t; ...                // Use this instead
       Object key; ...
       Object value; ...
       Object oldValue = t.put(key, value);
       if (oldValue == null) {
         // other code if not previously present
       }
       else {
         // other code if it was previously present
       }

Iterators and Enumerations (i.e., those returned by keySet().iterator(), entrySet().iterator(), values().iterator(), keys(), and elements()) return elements reflecting the state of the hash table at some point at or since the creation of the iterator/enumeration. They will return at most one instance of each element (via next()/nextElement()), but might or might not reflect puts and removes that have been processed since they were created. They do not throw ConcurrentModificationException. However, these iterators are designed to be used by only one thread at a time. Sharing an iterator across multiple threads may lead to unpredictable results if the table is being concurrently modified. Again, you can ensure interference-free iteration by enclosing the iteration in a synchronized block.

This class may be used as a direct replacement for any use of java.util.Hashtable that does not depend on readers being blocked during updates. Like Hashtable but unlike java.util.HashMap, this class does NOT allow `null` to be used as a key or value. This class is also typically faster than ConcurrentHashMap when there is usually only one thread updating the table, but possibly many retrieving values from it.

Implementation note: A slightly faster implementation of this class will be possible once planned Java Memory Model revisions are in place.

[ Introduction to this package. ]

See Also:
  Serialized Form

Nested Class Summary
`protected static class` | `AbstractConcurrentReadCache.Entry` AbstractConcurrentReadCache collision list entry.
`protected class` | `AbstractConcurrentReadCache.HashIterator`
`protected class` | `AbstractConcurrentReadCache.KeyIterator`
`protected class` | `AbstractConcurrentReadCache.ValueIterator`

Field Summary
`protected java.lang.Object` | `barrierLock` Lock used only for its memory effects.
`protected int` | `count` The total number of mappings in the hash table.
`static int` | `DEFAULT_INITIAL_CAPACITY` The default initial number of table slots for this table (32).
`static float` | `DEFAULT_LOAD_FACTOR` The default load factor for this table.
`protected int` | `DEFAULT_MAX_ENTRIES` Default cache capacity (number of entries).
`protected java.util.Set` | `entrySet`
`protected java.util.HashMap` | `groups` A HashMap containing the group information.
`protected java.util.Set` | `keySet`
`protected java.lang.Object` | `lastWrite` field written to only to guarantee lock ordering.
`protected float` | `loadFactor` The load factor for the hash table.
`protected static org.apache.commons.logging.Log` | `log`
`protected int` | `maxEntries` Cache capacity (number of entries).
`protected boolean` | `memoryCaching` Use memory cache or not.
`protected static java.lang.String` | `NULL`
`protected PersistenceListener` | `persistenceListener` Persistence listener.
`protected AbstractConcurrentReadCache.Entry[]` | `table` The hash table data.
`protected int` | `threshold` The table is rehashed when its size exceeds this threshold.
`protected int` | `UNLIMITED` Max number of element in cache when considered unlimited.
`protected boolean` | `unlimitedDiskCache` Use unlimited disk caching.
`protected java.util.Collection` | `values`

Constructor Summary
`AbstractConcurrentReadCache()` Constructs a new, empty map with a default initial capacity and load factor.
`AbstractConcurrentReadCache(int initialCapacity)` Constructs a new, empty map with the specified initial capacity and default load factor.
`AbstractConcurrentReadCache(int initialCapacity, float loadFactor)` Constructs a new, empty map with the specified initial capacity and the specified load factor.
`AbstractConcurrentReadCache(java.util.Map t)` Constructs a new map with the same mappings as the given map.

Method Summary
`int` | `capacity()` Return the number of slots in this table.
`void` | `clear()` Removes all mappings from this map.
`java.lang.Object` | `clone()` Returns a shallow copy of this.
`boolean` | `contains(java.lang.Object value)` Tests if some key maps into the specified value in this table.
`boolean` | `containsKey(java.lang.Object key)` Tests if the specified object is a key in this table.
`boolean` | `containsValue(java.lang.Object value)` Returns `true` if this map maps one or more keys to the specified value.
`java.util.Enumeration` | `elements()` Returns an enumeration of the values in this table.
`java.util.Set` | `entrySet()` Returns a collection view of the mappings contained in this map.
`protected boolean` | `findAndRemoveEntry(java.util.Map.Entry entry)` Helper method for entrySet remove.
`java.lang.Object` | `get(java.lang.Object key)` Returns the value to which the specified key is mapped in this table.
`java.util.Set` | `getGroup(java.lang.String groupName)` Returns a set of the cache keys that reside in a particular group.
`protected java.util.Map` | `getGroupsForReading()` Get ref to groups.
`int` | `getMaxEntries()` Retrieve the cache capacity (number of entries).
`PersistenceListener` | `getPersistenceListener()` Get the persistence listener.
`protected AbstractConcurrentReadCache.Entry[]` | `getTableForReading()` Get ref to table; the reference and the cells it accesses will be at least as fresh as from last use of barrierLock
`boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
`boolean` | `isMemoryCaching()` Check if memory caching is used.
`boolean` | `isUnlimitedDiskCache()` Check if we use unlimited disk cache.
`protected abstract void` | `itemPut(java.lang.Object key)` Notify the underlying implementation that an item was put in the cache.
`protected abstract void` | `itemRemoved(java.lang.Object key)` Notify the underlying implementation that an item was removed from the cache.
`protected abstract void` | `itemRetrieved(java.lang.Object key)` Notify any underlying algorithm that an item has been retrieved from the cache.
`java.util.Enumeration` | `keys()` Returns an enumeration of the keys in this table.
`java.util.Set` | `keySet()` Returns a set view of the keys contained in this map.
`float` | `loadFactor()` Return the load factor
`protected void` | `persistClear()` Removes the entire cache from persistent storage.
`protected void` | `persistRemove(java.lang.Object key)` Remove an object from the persistence.
`protected void` | `persistRemoveGroup(java.lang.String groupName)` Removes a cache group using the persistence listener.
`protected java.lang.Object` | `persistRetrieve(java.lang.Object key)` Retrieve an object from the persistence listener.
`protected java.util.Set` | `persistRetrieveGroup(java.lang.String groupName)` Retrieves a cache group using the persistence listener.
`protected void` | `persistStore(java.lang.Object key, java.lang.Object obj)` Store an object in the cache using the persistence listener.
`protected void` | `persistStoreGroup(java.lang.String groupName, java.util.Set group)` Creates or Updates a cache group using the persistence listener.
`java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)` OpenSymphony BEGIN
`void` | `putAll(java.util.Map t)` Copies all of the mappings from the specified map to this one.
`protected void` | `readObject(java.io.ObjectInputStream s)` Reconstitute the `AbstractConcurrentReadCache`.
`protected void` | `recordModification(java.lang.Object x)` Force a memory synchronization that will cause all readers to see table.
`protected void` | `rehash()` Rehashes the contents of this map into a new table with a larger capacity.
`java.lang.Object` | `remove(java.lang.Object key)` OpenSymphony BEGIN
`protected abstract java.lang.Object` | `removeItem()` The cache has reached its cacpacity and an item needs to be removed.
`void` | `setMaxEntries(int newLimit)` Set the cache capacity
`void` | `setMemoryCaching(boolean memoryCaching)` Sets the memory caching flag.
`void` | `setPersistenceListener(PersistenceListener listener)` Set the persistence listener to use.
`void` | `setUnlimitedDiskCache(boolean unlimitedDiskCache)` Sets the unlimited disk caching flag.
`int` | `size()` Returns the total number of cache entries held in this map.
`protected java.lang.Object` | `sput(java.lang.Object key, java.lang.Object value, int hash, boolean persist)` OpenSymphony BEGIN
`protected java.lang.Object` | `sremove(java.lang.Object key, int hash, boolean invokeAlgorithm)` OpenSymphony BEGIN
`java.util.Collection` | `values()` Returns a collection view of the values contained in this map.
`protected void` | `writeObject(java.io.ObjectOutputStream s)` Save the state of the `AbstractConcurrentReadCache` instance to a stream.

Methods inherited from class java.util.AbstractMap
`equals, hashCode, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`equals, hashCode`

Field Detail

### DEFAULT_INITIAL_CAPACITY

    public static int DEFAULT_INITIAL_CAPACITY

  The default initial number of table slots for this table (32). Used when not otherwise specified in constructor.

### DEFAULT_LOAD_FACTOR

    public static final float DEFAULT_LOAD_FACTOR

  The default load factor for this table. Used when not otherwise specified in constructor, the default is 0.75f.

  See Also:
    Constant Field Values

### NULL

    protected static final java.lang.String NULL

See Also:
  Constant Field Values

### log

    protected static final transient org.apache.commons.logging.Log log

### barrierLock

    protected final transient java.lang.Object barrierLock

  Lock used only for its memory effects.

### lastWrite

    protected transient java.lang.Object lastWrite

  field written to only to guarantee lock ordering.

### table

    protected transient AbstractConcurrentReadCache.Entry[] table

  The hash table data.

### count

    protected transient int count

  The total number of mappings in the hash table.

### persistenceListener

    protected PersistenceListener persistenceListener

  Persistence listener.

### memoryCaching

    protected boolean memoryCaching

  Use memory cache or not.

### unlimitedDiskCache

    protected boolean unlimitedDiskCache

  Use unlimited disk caching.

### loadFactor

    protected float loadFactor

  The load factor for the hash table.

### DEFAULT_MAX_ENTRIES

    protected final int DEFAULT_MAX_ENTRIES

  Default cache capacity (number of entries).

  See Also:
    Constant Field Values

### UNLIMITED

    protected final int UNLIMITED

  Max number of element in cache when considered unlimited.

  See Also:
    Constant Field Values

### values

    protected transient java.util.Collection values

### groups

    protected java.util.HashMap groups

  A HashMap containing the group information. Each entry uses the group name as the key, and holds a `Set` of containing keys of all the cache entries that belong to that particular group.

### entrySet

    protected transient java.util.Set entrySet

### keySet

    protected transient java.util.Set keySet

### maxEntries

    protected int maxEntries

  Cache capacity (number of entries).

### threshold

    protected int threshold

  The table is rehashed when its size exceeds this threshold. (The value of this field is always (int)(capacity * loadFactor).)

Constructor Detail

### AbstractConcurrentReadCache

    public AbstractConcurrentReadCache(int initialCapacity,
                                       float loadFactor)

  Constructs a new, empty map with the specified initial capacity and the specified load factor.

Parameters:
  `initialCapacity` - the initial capacity The actual initial capacity is rounded to the nearest power of two.
  `loadFactor` - the load factor of the AbstractConcurrentReadCache
Throws:
  `java.lang.IllegalArgumentException` - if the initial maximum number of elements is less than zero, or if the load factor is nonpositive.

### AbstractConcurrentReadCache

    public AbstractConcurrentReadCache(int initialCapacity)

  Constructs a new, empty map with the specified initial capacity and default load factor.

Parameters:
  `initialCapacity` - the initial capacity of the AbstractConcurrentReadCache.
Throws:
  `java.lang.IllegalArgumentException` - if the initial maximum number of elements is less than zero.

### AbstractConcurrentReadCache

    public AbstractConcurrentReadCache()

  Constructs a new, empty map with a default initial capacity and load factor.

### AbstractConcurrentReadCache

    public AbstractConcurrentReadCache(java.util.Map t)

  Constructs a new map with the same mappings as the given map. The map is created with a capacity of twice the number of mappings in the given map or 11 (whichever is greater), and a default load factor.

Method Detail

### isEmpty

    public boolean isEmpty()

  Returns `true` if this map contains no key-value mappings.

  Specified by:
    `isEmpty` in interface `java.util.Map`
  Returns:
    `true` if this map contains no key-value mappings.

### getGroup

    public java.util.Set getGroup(java.lang.String groupName)

  Returns a set of the cache keys that reside in a particular group.

  Parameters:
    `groupName` - The name of the group to retrieve.
  Returns:
    a set containing all of the keys of cache entries that belong to this group, or `null` if the group was not found.
  Throws:
    `java.lang.NullPointerException` - if the groupName is `null`.

### setMaxEntries

    public void setMaxEntries(int newLimit)

  Set the cache capacity

### getMaxEntries

    public int getMaxEntries()

  Retrieve the cache capacity (number of entries).

### setMemoryCaching

    public void setMemoryCaching(boolean memoryCaching)

  Sets the memory caching flag.

### isMemoryCaching

    public boolean isMemoryCaching()

  Check if memory caching is used.

### setPersistenceListener

    public void setPersistenceListener(PersistenceListener listener)

  Set the persistence listener to use.

### getPersistenceListener

    public PersistenceListener getPersistenceListener()

  Get the persistence listener.

### setUnlimitedDiskCache

    public void setUnlimitedDiskCache(boolean unlimitedDiskCache)

  Sets the unlimited disk caching flag.

### isUnlimitedDiskCache

    public boolean isUnlimitedDiskCache()

  Check if we use unlimited disk cache.

### capacity

    public int capacity()

  Return the number of slots in this table.

### clear

    public void clear()

  Removes all mappings from this map.

  Specified by:
    `clear` in interface `java.util.Map`

### clone

    public java.lang.Object clone()

  Returns a shallow copy of this. `AbstractConcurrentReadCache` instance: the keys and values themselves are not cloned.

  Returns:
    a shallow copy of this map.

### contains

    public boolean contains(java.lang.Object value)

  Tests if some key maps into the specified value in this table. This operation is more expensive than the `containsKey` method.

  Note that this method is identical in functionality to containsValue, (which is part of the Map interface in the collections framework).

  Parameters:
    `value` - a value to search for.
  Returns:
    `true` if and only if some key maps to the `value` argument in this table as determined by the `equals` method; `false` otherwise.
  Throws:
    `java.lang.NullPointerException` - if the value is `null`.
  See Also:
    `containsKey(Object)`, `containsValue(Object)`, `Map`

### containsKey

    public boolean containsKey(java.lang.Object key)

  Tests if the specified object is a key in this table.

  Specified by:
    `containsKey` in interface `java.util.Map`
  Parameters:
    `key` - possible key.
  Returns:
    `true` if and only if the specified object is a key in this table, as determined by the `equals` method; `false` otherwise.
  Throws:
    `java.lang.NullPointerException` - if the key is `null`.
  See Also:
    `contains(Object)`

### containsValue

    public boolean containsValue(java.lang.Object value)

  Returns `true` if this map maps one or more keys to the specified value. Note: This method requires a full internal traversal of the hash table, and so is much slower than method `containsKey`.

  Specified by:
    `containsValue` in interface `java.util.Map`
  Parameters:
    `value` - value whose presence in this map is to be tested.
  Returns:
    `true` if this map maps one or more keys to the specified value.
  Throws:
    `java.lang.NullPointerException` - if the value is `null`.

### elements

    public java.util.Enumeration elements()

  Returns an enumeration of the values in this table. Use the Enumeration methods on the returned object to fetch the elements sequentially.

  Returns:
    an enumeration of the values in this table.
  See Also:
    `Enumeration`, `keys()`, `values()`, `Map`

### entrySet

    public java.util.Set entrySet()

  Returns a collection view of the mappings contained in this map. Each element in the returned collection is a `Map.Entry`. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

  Specified by:
    `entrySet` in interface `java.util.Map`
  Returns:
    a collection view of the mappings contained in this map.

### get

    public java.lang.Object get(java.lang.Object key)

  Returns the value to which the specified key is mapped in this table.

  Specified by:
    `get` in interface `java.util.Map`
  Parameters:
    `key` - a key in the table.
  Returns:
    the value to which the key is mapped in this table; `null` if the key is not mapped to any value in this table.
  Throws:
    `java.lang.NullPointerException` - if the key is `null`.
  See Also:
    `put(Object, Object)`

### keySet

    public java.util.Set keySet()

  Returns a set view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

  Specified by:
    `keySet` in interface `java.util.Map`
  Returns:
    a set view of the keys contained in this map.

### keys

    public java.util.Enumeration keys()

  Returns an enumeration of the keys in this table.

  Returns:
    an enumeration of the keys in this table.
  See Also:
    `Enumeration`, `elements()`, `keySet()`, `Map`

### loadFactor

    public float loadFactor()

  Return the load factor

### put

    public java.lang.Object put(java.lang.Object key,
                                java.lang.Object value)

  OpenSymphony BEGIN

  Specified by:
    `put` in interface `java.util.Map`

### putAll

    public void putAll(java.util.Map t)

  Copies all of the mappings from the specified map to this one. These mappings replace any mappings that this map had for any of the keys currently in the specified Map.

  Specified by:
    `putAll` in interface `java.util.Map`
  Parameters:
    `t` - Mappings to be stored in this map.

### remove

    public java.lang.Object remove(java.lang.Object key)

  OpenSymphony BEGIN

  Specified by:
    `remove` in interface `java.util.Map`

### size

    public int size()

  Returns the total number of cache entries held in this map.

  Specified by:
    `size` in interface `java.util.Map`
  Returns:
    the number of key-value mappings in this map.

### values

    public java.util.Collection values()

  Returns a collection view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

  Specified by:
    `values` in interface `java.util.Map`
  Returns:
    a collection view of the values contained in this map.

### getGroupsForReading

    protected final java.util.Map getGroupsForReading()

  Get ref to groups. The reference and the cells it accesses will be at least as fresh as from last use of barrierLock

### getTableForReading

    protected final AbstractConcurrentReadCache.Entry[] getTableForReading()

  Get ref to table; the reference and the cells it accesses will be at least as fresh as from last use of barrierLock

### recordModification

    protected final void recordModification(java.lang.Object x)

  Force a memory synchronization that will cause all readers to see table. Call only when already holding main synch lock.

### findAndRemoveEntry

    protected boolean findAndRemoveEntry(java.util.Map.Entry entry)

  Helper method for entrySet remove.

### persistRemove

    protected void persistRemove(java.lang.Object key)

  Remove an object from the persistence.

  Parameters:
    `key` - The key of the object to remove

### persistRemoveGroup

    protected void persistRemoveGroup(java.lang.String groupName)

  Removes a cache group using the persistence listener.

  Parameters:
    `groupName` - The name of the group to remove

### persistRetrieve

    protected java.lang.Object persistRetrieve(java.lang.Object key)

  Retrieve an object from the persistence listener.

  Parameters:
    `key` - The key of the object to retrieve

### persistRetrieveGroup

    protected java.util.Set persistRetrieveGroup(java.lang.String groupName)

  Retrieves a cache group using the persistence listener.

  Parameters:
    `groupName` - The name of the group to retrieve

### persistStore

    protected void persistStore(java.lang.Object key,
                                java.lang.Object obj)

  Store an object in the cache using the persistence listener.

  Parameters:
    `key` - The object key
    `obj` - The object to store

### persistStoreGroup

    protected void persistStoreGroup(java.lang.String groupName,
                                     java.util.Set group)

  Creates or Updates a cache group using the persistence listener.

  Parameters:
    `groupName` - The name of the group to update
    `group` - The entries for the group

### persistClear

    protected void persistClear()

  Removes the entire cache from persistent storage.

### itemPut

    protected abstract void itemPut(java.lang.Object key)

  Notify the underlying implementation that an item was put in the cache.

  Parameters:
    `key` - The cache key of the item that was put.

### itemRetrieved

    protected abstract void itemRetrieved(java.lang.Object key)

  Notify any underlying algorithm that an item has been retrieved from the cache.

  Parameters:
    `key` - The cache key of the item that was retrieved.

### itemRemoved

    protected abstract void itemRemoved(java.lang.Object key)

  Notify the underlying implementation that an item was removed from the cache.

  Parameters:
    `key` - The cache key of the item that was removed.

### removeItem

    protected abstract java.lang.Object removeItem()

  The cache has reached its cacpacity and an item needs to be removed. (typically according to an algorithm such as LRU or FIFO).

  Returns:
    The key of whichever item was removed.

### readObject

    protected void readObject(java.io.ObjectInputStream s)
                       throws java.io.IOException,
                              java.lang.ClassNotFoundException

  Reconstitute the `AbstractConcurrentReadCache`. instance from a stream (i.e., deserialize it).

  Throws:
    `java.io.IOException`
    `java.lang.ClassNotFoundException`

### rehash

    protected void rehash()

  Rehashes the contents of this map into a new table with a larger capacity. This method is called automatically when the number of keys in this map exceeds its capacity and load factor.

### sput

    protected java.lang.Object sput(java.lang.Object key,
                                    java.lang.Object value,
                                    int hash,
                                    boolean persist)

  OpenSymphony BEGIN

### sremove

    protected java.lang.Object sremove(java.lang.Object key,
                                       int hash,
                                       boolean invokeAlgorithm)

  OpenSymphony BEGIN

### writeObject

    protected void writeObject(java.io.ObjectOutputStream s)
                        throws java.io.IOException

  Save the state of the `AbstractConcurrentReadCache` instance to a stream. (i.e., serialize it).

  Throws:
    `java.io.IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| See www.opensymphony.com for more information.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD